// -*-Java-*-
/*!
 * @file  diManagementSVC_impl.java
 * @brief Service implementation code of DataInterpretationModule.idl
 *
 */

import jp.co.ritecs.DataInterpretationModule.RTC.*;
import jp.go.aist.rtm.RTC.port.CorbaConsumer;

import com.nec.qnes.tms2.RTC.api.*;
import com.nec.qnes.tms2.RTC.data.*;

/*!
 * @class diManagementSVC_impl
 * Example class implementing IDL interface jp::co::ritecs::DataInterpretationModule::RTC::diManagement
 */
public class diManagementSVC_impl extends diManagementPOA{
	
    public CorbaConsumer<TmsSystem> m_tmssystemBase;
    public CorbaConsumer<Auth> m_authBase;
	protected TmsSystem m_tmssystem;
	protected Auth m_auth;
	
	protected String m_deviceid;
	protected String m_userid;
	protected String m_password;
	
	protected Auth m_localauth;
	protected AuthToken m_localtoken;

	public diTagSVC_impl m_if_diTag;
	public diObjectSVC_impl m_if_diObject;
	public diRobotSVC_impl m_if_diRobot;
    
    public diManagementSVC_impl() {
        // Please add extra constructor code here.
    	m_deviceid = "robot1";
    	m_userid = "user1";
    	m_password = "abc";

    	m_localauth = null;
    	m_localtoken = null;
    }

    /*
     * Methods corresponding to IDL attributes and operations
     */
    public int setLoginInfo(String deviceid, String userid, String password) {
        // Please insert your code here and remove the following warning pragma
        // TODO "Code missing in function <int setLoginInfo(String deviceid, String userid, String password)>"
    	m_deviceid = deviceid;
    	m_userid = userid;
    	m_password = password;
    	
        System.out.println( "setLoginInfo: " + m_deviceid + "/" + m_userid + "/" + m_password);
        return 0;
    }

    public int Open() {
        // Please insert your code here and remove the following warning pragma
        // TODO "Code missing in function <int Open()>"
    	m_tmssystem = m_tmssystemBase._ptr();
    	m_auth = m_authBase._ptr();
   	
    	int ret = 0;
    	
    	System.out.println("Open ...");
    	
        System.out.println("CALL TmsSystem.isInitialized()");

        boolean binit = m_tmssystem.isInitialized();

        System.out.println("return result: "+ binit);

        // ̏ꍇ̂initializes
        if (binit == false) {

        	////////////////////////////////////////
        	// TmsSystem.initialize()
        	System.out.println("CALL TmsSystem.initialize()");

        	ret = m_tmssystem.initialize();

        	System.out.println("return code: "+ret);

        	if (ret < 0) {
        		return ret;
        	}
        }

        //
        // OC
        //

		////////////////////////////////////////
        // Auth.getInstance()
        System.out.println("CALL Auth.getInstance()");

        m_localauth = m_auth.getInstance(m_deviceid, m_userid, m_password);
        
        // API OK/NG͕Ԓlnull/nullŔf܂
        if (m_localauth == null) {
        	System.out.println("failed");
            return -1;
        }

        System.out.println("auth deviceid/userid: "
        		+ m_localauth.deviceid() + "/" + m_localauth.userid());

		////////////////////////////////////////
        // Auth.login()
        System.out.println("CALL Auth.login()");

        m_localtoken = m_localauth.login();

        if (m_localtoken == null) {
            // OCs
        	System.out.println("failed");
            return -1;
        }
        
        m_if_diTag.m_localtoken = m_localtoken;
        m_if_diObject.m_localtoken = m_localtoken;
        m_if_diRobot.m_localtoken = m_localtoken;

        System.out.println("local_token deviceid/userid: "
        		+ m_localtoken.deviceid + "/" + m_localtoken.userid);

        System.out.println("Open OK.");
        return 0;
    }

    public int Close() {
        // Please insert your code here and remove the following warning pragma
        // TODO "Code missing in function <int Close()>"
    	m_tmssystem = m_tmssystemBase._ptr();
    	m_auth = m_authBase._ptr();

    	int ret = 0;
    	
    	System.out.println("Close ...");
    	
    	if (m_localauth == null) {
    		System.out.println("not open.");
    		return -1;
    	}
    	
        //
        // OAEg
        //

        //////////////////////////////////////
        // Auth.logout()
        System.out.println("CALL Auth.logout()");

        ret = m_localauth.logout();

        System.out.println("return code: "+ret);

        if (ret < 0) {
        	System.out.println("failed by code: "+ret);
        	return ret;
        }

        m_if_diTag.m_localtoken = null;
        m_if_diObject.m_localtoken = null;
        m_if_diRobot.m_localtoken = null;

        //
        // VXeI
        //

        //////////////////////////////////////
        // TmsSystem.destroy()
        System.out.println("CALL TmsSystem.destroy()");

        ret = m_tmssystem.destroy();

        System.out.println("return code: "+ret);

        if (ret < 0) {
        	System.out.println("failed by code: "+ret);
        	return ret;
        }
        
        System.out.println("Close OK.");
        return 0;
    }

//  End of example implementational code
}
