// -*-Java-*-
/*!
 * @file  diTagSVC_impl.java
 * @brief Service implementation code of DataInterpretationModule.idl
 *
 */
import jp.co.ritecs.DataInterpretationModule.RTC.*;
import jp.co.ritecs.DataInterpretationModule.RTC.diData.*;
import jp.go.aist.rtm.RTC.port.CorbaConsumer;

import com.nec.qnes.tms2.RTC.api.*;
import com.nec.qnes.tms2.RTC.data.*;

import java.util.ArrayList;

/*!
 * @class diTagSVC_impl
 * Example class implementing IDL interface jp::co::ritecs::DataInterpretationModule::RTC::diTag
 */
public class diTagSVC_impl extends diTagPOA{
	
	public CorbaConsumer<Tag> m_tagBase;
	protected Tag m_tag;
	
	public AuthToken m_localtoken;
    
    public diTagSVC_impl() {
        // Please add extra constructor code here.
    }

    /*
     * Methods corresponding to IDL attributes and operations
     */
    public int setContentObject(diTagInfo[] infos) {
        // Please insert your code here and remove the following warning pragma
        // TODO "Code missing in function <int setContentObject(diData::diTagInfoList infos)>"
    	System.out.println("Set Content Object was called.");
    	
       m_tag = m_tagBase._ptr();
        
        if(m_localtoken == null) {
        	System.out.println("no login");
        	return -1;
        }
        
        int ret = 0;
        
        Tag tag = m_tag.getInstance(m_localtoken);
        
        if(tag == null) {
        	System.out.println("failed");
        	return -1;
        }
    	
        TagInfo[] taginfos = new TagInfo[infos.length];
        
    	for(int i=0; i < infos.length; i++) {
    		
    		taginfos[i] = new TagInfo();
    		taginfos[i].tagid = infos[i].tagid;
    		
    		diContentObjectInfo dicon = new diContentObjectInfo();
    		dicon = infos[i].obj.m_contentObjectInfo();

    		ContentObjectInfo _obj = new ContentObjectInfo();
    		_obj.name = dicon.name;
    		_obj.color = dicon.color;
    		_obj.size = dicon.size;
    		_obj.type = dicon.type;
    		_obj.manufacturer = dicon.manufacturer;
    		TimeVal date = new TimeVal();
    		date.msec = dicon.registration.msec;
    		_obj.registration = date;
    		_obj.comment = dicon.comment;
    		_obj.width = dicon.width;
    		_obj.depth = dicon.depth;
    		_obj.height = dicon.height;
    		date.msec = dicon.history.msec;
    		_obj.history = date;
    		_obj.status = dicon.status;
    		_obj.schedule = dicon.schedule;
    		_obj.cabinettype = dicon.cabinettype;
    		_obj.cabinetid = dicon.cabinetid;
    		
    		TagObjectInfo obj = new TagObjectInfo();
    		obj.m_contentObjectInfo(_obj);
    		taginfos[i].obj = obj;
    		
    		TagLocationInfo loc = new TagLocationInfo();
    		loc.additionalInfo = infos[i].loc.additionalInfo;
    		date.msec = infos[i].loc.time.msec;
    		loc.time = date;
    		loc.coordinateX = infos[i].loc.coordinateX;
    		loc.coordinateY = infos[i].loc.coordinateY;
    		loc.coordinateZ = infos[i].loc.coordinateZ;
    		loc.orientP = infos[i].loc.orientP;
    		loc.orientR = infos[i].loc.orientR;
    		loc.orientY = infos[i].loc.orientY;
    		loc.velocityX = infos[i].loc.velocityX;
    		loc.velocityY = infos[i].loc.velocityY;
    		loc.velocityZ = infos[i].loc.velocityZ;
    		loc.locType = infos[i].loc.locType;
    		
    		taginfos[i].loc = loc;
    		
    		TagTaskInfo task = new TagTaskInfo();
    		task.task = infos[i].task.task;
    		
    		taginfos[i].task = task;
    		
    	}
    	
    	System.out.println("Call setTagInfo()");
    	ret = m_tag.setTagInfo(taginfos);
    	
    	System.out.println("return code: " + ret);
    	
    	if(ret < 0) {
    		System.out.println("error");
    	} else {
    		System.out.println("ok");
    	}
    	
        return ret;
    }

    public int getContentObjectByTag(String tagID, diContentObjectInfoHolder con) {
        // Please insert your code here and remove the following warning pragma
        // TODO "Code missing in function <int getContentObjectByTag(String tagID, diData::diContentObjectInfo con)>"
        System.out.println("Get Content Object By Tag was called.");
        
        m_tag = m_tagBase._ptr();
        
        if(m_localtoken == null) {
        	System.out.println("no login");
        	return -1;
        }
        
        int ret = 0;
        
        Tag tag = m_tag.getInstance(m_localtoken);
        
        if(tag == null) {
        	System.out.println("failed");
        	return -1;
        }
        
        String[] tagids = new String[1];
        tagids[0] = tagID;
        TagInfoListHolder taginfos = new TagInfoListHolder();
        taginfos.value = new TagInfo[0];
        
        System.out.println("CALL getTagInfo()");
        
        ret = m_tag.getTagInfo(tagids, taginfos);
        
    	System.out.println("return code: " + ret);
        
        if(ret < 0) {
        	System.out.println("error");
        	
			con.value = new diContentObjectInfo();
			
			con.value.name = "";
			con.value.color = 0;
			con.value.size = "";
			con.value.type = 0;
			con.value.manufacturer = "";
    		diTimeVal date = new diTimeVal();
    		date.msec = 0;
			con.value.registration = date;
			con.value.comment = "";
			con.value.width = 0;
			con.value.depth = 0;
			con.value.height = 0;
			con.value.history = date;
			con.value.status = 0;
			con.value.schedule = "";
			con.value.cabinettype = 0;
			con.value.cabinetid = "";
			
        } else {
        	TagInfo taginfo = taginfos.value[0];
        	TagObjectInfo obj = taginfo.obj;
        	if(obj != null) {
        		// [񂪑݂ꍇ
        		if(obj.discriminator() == TagObjectInfoDerivedType.CONTENT_OBJECT_INFO) {
        			// ContentObjectInfo̎o
        			ContentObjectInfo content = obj.m_contentObjectInfo();
        			
        			con.value = new diContentObjectInfo();
        			
        			con.value.name = content.name;
        			con.value.color = content.color;
        			con.value.size = content.size;
        			con.value.type = content.type;
        			con.value.manufacturer = content.manufacturer;
    	    		diTimeVal date = new diTimeVal();
    	    		date.msec = content.registration.msec;
        			con.value.registration = date;
        			con.value.comment = content.comment;
        			con.value.width = content.width;
        			con.value.depth = content.depth;
        			con.value.height = content.height;
        			date.msec = content.history.msec;
        			con.value.history = date;
        			con.value.status = content.status;
        			con.value.schedule = content.schedule;
        			con.value.cabinettype = content.cabinettype;
        			con.value.cabinetid = content.cabinetid;        			
        			
        			System.out.println("ok");
        		} else {
        			System.out.println("Not Content Object");
        			
        			con.value = new diContentObjectInfo();
        			
        			con.value.name = "";
        			con.value.color = 0;
        			con.value.size = "";
        			con.value.type = 0;
        			con.value.manufacturer = "";
            		diTimeVal date = new diTimeVal();
            		date.msec = 0;
        			con.value.registration = date;
        			con.value.comment = "";
        			con.value.width = 0;
        			con.value.depth = 0;
        			con.value.height = 0;
        			con.value.history = date;
        			con.value.status = 0;
        			con.value.schedule = "";
        			con.value.cabinettype = 0;
        			con.value.cabinetid = "";
        		}
        	}
        }
        
    	return ret;

    }

    public int setCabinetObject(diTagInfo[] infos) {
        // Please insert your code here and remove the following warning pragma
        // TODO "Code missing in function <int setCabinetObject(diData::diTagInfoList infos)>"
    	System.out.println("Set Cabinet Object was called");
    	
    	m_tag = m_tagBase._ptr();
        
        if(m_localtoken == null) {
        	System.out.println("no login");
        	return -1;
        }
        
        int ret = 0;
        
        Tag tag = m_tag.getInstance(m_localtoken);
        
        if(tag == null) {
        	System.out.println("failed");
        	return -1;
        }
    	
        TagInfo[] taginfos = new TagInfo[infos.length];
        
    	for(int i=0; i < infos.length; i++) {
    		
    		taginfos[i] = new TagInfo();
    		taginfos[i].tagid = infos[i].tagid;
    		
    		diCabinetObjectInfo dicab = new diCabinetObjectInfo();
    		dicab = infos[i].obj.m_cabinetObjectInfo();

    		CabinetObjectInfo _obj = new CabinetObjectInfo();
    		_obj.name = dicab.name;
    		_obj.color = dicab.color;
    		_obj.size = dicab.size;
    		_obj.type = dicab.type;
    		_obj.manufacturer = dicab.manufacturer;
    		TimeVal date = new TimeVal();
    		date.msec = dicab.registration.msec;
    		_obj.registration = date;
    		_obj.additionalinfo = dicab.additionalinfo;
    		_obj.width = dicab.width;
    		_obj.depth = dicab.depth;
    		_obj.height = dicab.height;
    		_obj.capacity = dicab.capacity;
    		_obj.sens_start_x = dicab.sens_start_x;
    		_obj.sens_start_y = dicab.sens_start_y;
    		_obj.sens_start_z = dicab.sens_start_z;
    		_obj.sens_width = dicab.sens_width;
    		
    		System.out.println("set contentids");
    		String[] contentids = new String[dicab.contentids.length];
    		for(int j=0; j < dicab.contentids.length; j++) {
    			contentids[j] = dicab.contentids[j];
    		}
    		_obj.contentids = contentids;
    		System.out.println("contentids set");
    		
    		TagObjectInfo obj = new TagObjectInfo();
    		obj.m_cabinetObjectInfo(_obj);
    		taginfos[i].obj = obj;
    		
    		TagLocationInfo loc = new TagLocationInfo();
    		loc.additionalInfo = infos[i].loc.additionalInfo;
    		date.msec = infos[i].loc.time.msec;
    		loc.time = date;
    		loc.coordinateX = infos[i].loc.coordinateX;
    		loc.coordinateY = infos[i].loc.coordinateY;
    		loc.coordinateZ = infos[i].loc.coordinateZ;
    		loc.orientP = infos[i].loc.orientP;
    		loc.orientR = infos[i].loc.orientR;
    		loc.orientY = infos[i].loc.orientY;
    		loc.velocityX = infos[i].loc.velocityX;
    		loc.velocityY = infos[i].loc.velocityY;
    		loc.velocityZ = infos[i].loc.velocityZ;
    		loc.locType = infos[i].loc.locType;
    		
    		taginfos[i].loc = loc;
    		
    		TagTaskInfo task = new TagTaskInfo();
    		task.task = infos[i].task.task;
    		
    		taginfos[i].task = task;
    		
    	}
    	
    	System.out.println("Call setTagInfo()");
    	ret = m_tag.setTagInfo(taginfos);
    	
    	System.out.println("return code: " + ret);
    	
    	if(ret < 0) {
    		System.out.println("error");
    	} else {
    		System.out.println("ok");
    	}
    	
        return ret;
        
    }

    public int getCabinetObjectByTag(String tagID, diCabinetObjectInfoHolder cab) {
        // Please insert your code here and remove the following warning pragma
        // TODO "Code missing in function <int getCabinetObjectByTag(String tagID, diData::diCabinetObjectInfo cab)>"
        System.out.println("Get Cabinet Object By Tag was called.");
        
        m_tag = m_tagBase._ptr();
         
         if(m_localtoken == null) {
         	System.out.println("no login");
         	return -1;
         }
         
         int ret = 0;
         
         Tag tag = m_tag.getInstance(m_localtoken);
         
         if(tag == null) {
         	System.out.println("failed");
         	return -1;
         }
         
         String[] tagids = new String[1];
         tagids[0] = tagID;
         TagInfoListHolder taginfos = new TagInfoListHolder();
         taginfos.value = new TagInfo[0];
         ret = m_tag.getTagInfo(tagids, taginfos);
         
         System.out.println("return code: " + ret);
         
         if(ret < 0) {
         	System.out.println("error");
 			cab.value = new diCabinetObjectInfo();
 			
 			cab.value.name = "";
 			cab.value.color = 0;
 			cab.value.size = "";
 			cab.value.type = 0;
 			cab.value.manufacturer = "";
    		diTimeVal date = new diTimeVal();
    		date.msec = 0;
 			cab.value.registration = date;
 			cab.value.additionalinfo = "";
 			cab.value.width = 0;
 			cab.value.depth = 0;
 			cab.value.height = 0;
 			cab.value.capacity = 0;
 			cab.value.space = 0;
 			cab.value.sens_start_x = 0;
 			cab.value.sens_start_y = 0;
 			cab.value.sens_start_z = 0;
 			cab.value.sens_width = 0;
 			String[] contentids = new String[1];
 			contentids[0] = "";
 			cab.value.contentids = contentids;
 			
         } else {
         	TagInfo taginfo = taginfos.value[0];
         	TagObjectInfo obj = taginfo.obj;
         	if(obj != null) {
         		// [I񂪑݂ꍇ
         		if(obj.discriminator() == TagObjectInfoDerivedType.CABINET_OBJECT_INFO) {
         			CabinetObjectInfo cabinet = obj.m_cabinetObjectInfo();
         			
         			cab.value = new diCabinetObjectInfo();
         			
         			cab.value.name = cabinet.name;
         			cab.value.color = cabinet.color;
         			cab.value.size = cabinet.size;
         			cab.value.type = cabinet.type;
         			cab.value.manufacturer = cabinet.manufacturer;
    	    		diTimeVal date = new diTimeVal();
    	    		date.msec = cabinet.registration.msec;
         			cab.value.registration = date;
         			cab.value.additionalinfo = cabinet.additionalinfo;
         			cab.value.width = cabinet.width;
         			cab.value.depth = cabinet.depth;
         			cab.value.height = cabinet.height;
         			cab.value.capacity = cabinet.capacity;
         			cab.value.space = cabinet.space;
         			cab.value.sens_start_x = cabinet.sens_start_x;
         			cab.value.sens_start_y = cabinet.sens_start_y;
         			cab.value.sens_start_z = cabinet.sens_start_z;
         			cab.value.sens_width = cabinet.sens_width;
         			cab.value.contentids = cabinet.contentids;
         			
         			System.out.println("ok");
         			
         		} else {
         			System.out.println("Not Cabinet Object");
         			
         			cab.value = new diCabinetObjectInfo();
         			
         			cab.value.name = "";
         			cab.value.color = 0;
         			cab.value.size = "";
         			cab.value.type = 0;
         			cab.value.manufacturer = "";
            		diTimeVal date = new diTimeVal();
            		date.msec = 0;
         			cab.value.registration = date;
         			cab.value.additionalinfo = "";
         			cab.value.width = 0;
         			cab.value.depth = 0;
         			cab.value.height = 0;
         			cab.value.capacity = 0;
         			cab.value.space = 0;
         			cab.value.sens_start_x = 0;
         			cab.value.sens_start_y = 0;
         			cab.value.sens_start_z = 0;
         			cab.value.sens_width = 0;
         			String[] contentids = new String[1];
         			contentids[0] = "";
         			cab.value.contentids = contentids;
         		}
         	}
         }
         
     	return ret;

    }

    public int setTagObject(diTagInfo[] infos) {
        // Please insert your code here and remove the following warning pragma
        // TODO "Code missing in function <int setTagObject(diData::diTagInfoList infos)>"
    	System.out.println("set Tag Object was called.");
        
       m_tag = m_tagBase._ptr();
        
        if(m_localtoken == null) {
        	System.out.println("no login");
        	return -1;
        }
        
        int ret = 0;
        
        Tag tag = m_tag.getInstance(m_localtoken);
        
        if(tag == null) {
        	System.out.println("failed");
        	return -1;
        }
    	
        TagInfo[] taginfos = new TagInfo[infos.length];
        
    	for(int i=0; i < infos.length; i++) {
    		
    		taginfos[i] = new TagInfo();
    		taginfos[i].tagid = infos[i].tagid;
    		
    		diTagObjectInfoSuper ditag = new diTagObjectInfoSuper();
    		ditag = infos[i].obj.m_tagObjectInfo();

    		TagObjectInfoSuper _obj = new TagObjectInfoSuper();
    		_obj.name = ditag.name;
    		_obj.color = ditag.color;
    		_obj.size = ditag.size;
    		
    		TagObjectInfo obj = new TagObjectInfo();
    		obj.m_tagObjectInfo(_obj);
    		taginfos[i].obj = obj;
    		
    		TagLocationInfo loc = new TagLocationInfo();
    		loc.additionalInfo = infos[i].loc.additionalInfo;
    		TimeVal date = new TimeVal();
    		date.msec = infos[i].loc.time.msec;
    		loc.time = date;
    		loc.coordinateX = infos[i].loc.coordinateX;
    		loc.coordinateY = infos[i].loc.coordinateY;
    		loc.coordinateZ = infos[i].loc.coordinateZ;
    		loc.orientP = infos[i].loc.orientP;
    		loc.orientR = infos[i].loc.orientR;
    		loc.orientY = infos[i].loc.orientY;
    		loc.velocityX = infos[i].loc.velocityX;
    		loc.velocityY = infos[i].loc.velocityY;
    		loc.velocityZ = infos[i].loc.velocityZ;
    		loc.locType = infos[i].loc.locType;
    		
    		taginfos[i].loc = loc;
    		
    		TagTaskInfo task = new TagTaskInfo();
    		task.task = infos[i].task.task;
    		
    		taginfos[i].task = task;
    		
    	}
    	
    	System.out.println("Call setTagInfo()");
    	ret = m_tag.setTagInfo(taginfos);
    	
    	System.out.println("return code: " + ret);
    	
    	if(ret < 0) {
    		System.out.println("error");
    	} else {
    		System.out.println("ok");
    	}
    	
        return ret;
        
    }

    public int getTagLocationByTag(String tagID, diTagLocationInfoHolder loc) {
        // Please insert your code here and remove the following warning pragma
        // TODO "Code missing in function <int getTagLocationByTag(String tagID, diData::diTagLocationInfo loc)>"
        System.out.println("Get Tag Location By Tag was called.");
        
        m_tag = m_tagBase._ptr();
        
        if(m_localtoken == null) {
        	System.out.println("no login");
        	return -1;
        }
        
        int ret = 0;
        
        Tag tag = m_tag.getInstance(m_localtoken);
        
        if(tag == null) {
        	System.out.println("failed");
        	return -1;
        }
        
        String[] tagids = new String[1];
        tagids[0] = tagID;
        TagInfoListHolder taginfos = new TagInfoListHolder();
        taginfos.value = new TagInfo[0];
        ret = m_tag.getTagInfo(tagids, taginfos);
        
        System.out.println("return code: " + ret);
        
        if(ret < 0) {
        	System.out.println("error");
			loc.value = new diTagLocationInfo();
			
			loc.value.additionalInfo = "";
    		diTimeVal date = new diTimeVal();
    		date.msec = 0;
			loc.value.time = date;
			loc.value.coordinateX = 0;
			loc.value.coordinateY = 0;
			loc.value.coordinateZ = 0;
			loc.value.orientP = 0;
			loc.value.orientR = 0;
			loc.value.orientY = 0;
			loc.value.velocityX = 0;
			loc.value.velocityY = 0;
			loc.value.velocityZ = 0;
			loc.value.locType = 0;
        } else {
        	TagInfo taginfo = taginfos.value[0];
        	TagObjectInfo obj = taginfo.obj;
        	if(obj != null) {
        		// ʒu񂪑݂ꍇ
        		TagLocationInfo location = taginfo.loc;
        		if(location != null) {
        			loc.value = new diTagLocationInfo();
        			
        			loc.value.additionalInfo = location.additionalInfo;
    	    		diTimeVal date = new diTimeVal();
    	    		date.msec = location.time.msec;
        			loc.value.time = date;
        			loc.value.coordinateX = location.coordinateX;
        			loc.value.coordinateY = location.coordinateY;
        			loc.value.coordinateZ = location.coordinateZ;
        			loc.value.orientP = location.orientP;
        			loc.value.orientR = location.orientR;
        			loc.value.orientY = location.orientY;
        			loc.value.velocityX = location.velocityX;
        			loc.value.velocityY = location.velocityY;
        			loc.value.velocityZ = location.velocityZ;
        			loc.value.locType = location.locType;
        			
        	    	// ContentObject̏ꍇWϊ
        	        if(obj.discriminator() == TagObjectInfoDerivedType.CONTENT_OBJECT_INFO) {
        	        	System.out.println("ContentObject");
        	        	System.out.println("Coordinate Transformation");
        	        	
        	        	ContentObjectInfo temp_content = new ContentObjectInfo();
        	        	temp_content = obj.m_contentObjectInfo();
        	            String[] tagids_of_cabinet = new String[1];
        	            tagids_of_cabinet[0] = temp_content.cabinetid;
        	            TagInfoListHolder taginfos_of_cabinet = new TagInfoListHolder();
        	            taginfos_of_cabinet.value = new TagInfo[0];
        	            
        	            int temp_ret = 0;
        	            temp_ret = m_tag.getTagInfo(tagids_of_cabinet, taginfos_of_cabinet);
        	            
        	        	System.out.println("return code: " + temp_ret);

        	            if (temp_ret < 0) {
        	            	System.out.println("error");
        	            }
        	            else {
        	            
        	            	TagInfo temp_taginfo = taginfos_of_cabinet.value[0];
        	            	double temp_coordinateX = loc.value.coordinateX;
        	            	double temp_coordinateY = loc.value.coordinateY;
        	            	double temp_coordinateZ = loc.value.coordinateZ;
        	            	double temp_orientP = Math.toRadians(temp_taginfo.loc.orientP);
        	            	double temp_orientR = Math.toRadians(temp_taginfo.loc.orientR);
        	            	double temp_orientY = Math.toRadians(temp_taginfo.loc.orientY);
        	            
        	            	loc.value.coordinateX = temp_taginfo.loc.coordinateX + (Math.cos(temp_orientR) * Math.cos(temp_orientY) * temp_coordinateX) - (Math.cos(temp_orientR) * Math.sin(temp_orientY) * temp_coordinateY) + (Math.sin(temp_orientR) * temp_coordinateZ);
        	            	loc.value.coordinateY = temp_taginfo.loc.coordinateY + (Math.sin(temp_orientP)*Math.sin(temp_orientR)*Math.cos(temp_orientY) + Math.cos(temp_orientP)*Math.sin(temp_orientY)) * temp_coordinateX + (Math.cos(temp_orientP)*Math.cos(temp_orientY) - Math.sin(temp_orientP)*Math.sin(temp_orientR)*Math.sin(temp_orientY)) * temp_coordinateY - Math.sin(temp_orientP)*Math.cos(temp_orientR) * temp_coordinateZ;
        	            	loc.value.coordinateZ = temp_taginfo.loc.coordinateZ + (Math.sin(temp_orientP)*Math.sin(temp_orientY) - Math.cos(temp_orientP)*Math.sin(temp_orientR)*Math.cos(temp_orientY)) * temp_coordinateX + (Math.cos(temp_orientP)*Math.sin(temp_orientR)*Math.sin(temp_orientY) + Math.sin(temp_orientP)*Math.cos(temp_orientY)) * temp_coordinateY + Math.cos(temp_orientP)*Math.cos(temp_orientR)*temp_coordinateZ;
        	            	loc.value.orientP += temp_orientP;
        	            	loc.value.orientR += temp_orientR;
        	            	loc.value.orientY += temp_orientY;
        	            }
        	            

        	        }
        	        else if(obj.discriminator() == TagObjectInfoDerivedType.CABINET_OBJECT_INFO) {
        	        	System.out.println("CabinetObject");
        	        }
        	        else if(obj.discriminator() == TagObjectInfoDerivedType.TAG_OBJECT_INFO) {
        	        	System.out.println("TagObject");
        	        }
        			
        			System.out.println("ok");
        		}
        	}
        }
        
        return ret;

    }

    public int getTagByName(String name, diStringListHolder tagIDs) {
        // Please insert your code here and remove the following warning pragma
        // TODO "Code missing in function <int getTagByName(String name, diData::diStringList tagIDs)>"
        System.out.println("Get Tag By Name was called.");
        
        m_tag = m_tagBase._ptr();
         
         if(m_localtoken == null) {
         	System.out.println("no login");
         	return -1;
         }
         
         int ret = 0;
         
         Tag tag = m_tag.getInstance(m_localtoken);
         
         if(tag == null) {
         	System.out.println("failed");
         	return -1;
         }
         
         ContentObjectInfo _objInfo = new ContentObjectInfo();
         
         String[] keys = new String[]{"NAME"};
         _objInfo.name = name;
         _objInfo.color = 0;
         _objInfo.size = "size";
         _objInfo.type = 0;
         _objInfo.manufacturer = "manufacturer";
         TimeVal date = new TimeVal();
         date.msec = 0;
         _objInfo.registration = date;
         _objInfo.comment = "comment";
         _objInfo.width = 0;
         _objInfo.depth = 0;
         _objInfo.height = 0;
         _objInfo.history = date;
         _objInfo.status = 0;
         _objInfo.schedule = "schedule";
         _objInfo.cabinettype = 0;
         _objInfo.cabinetid = "cabinetid";
         
         
         TagObjectInfo objInfo = new TagObjectInfo();
         objInfo.m_contentObjectInfo(_objInfo);
         
         TagObjectInfo_Key objInfo_key = new TagObjectInfo_Key(objInfo, keys);
         TagObjectInfo_Key[] objInfo_keys = new TagObjectInfo_Key[]{objInfo_key};
         
         StringListListHolder tagIds = new StringListListHolder();

         System.out.println("CALL getTagIDByObjectInfo()");
         ret = m_tag.getTagIDByObjectInfo(objInfo_keys, tagIds);
         
         System.out.println("return code: " + ret);
                  
         if(ret < 0) {
         	System.out.println("error");
         	tagIDs.value = new String[1];
         	tagIDs.value[0] = "";
         } else {
        	 int contentnum = 0;
          	for(int i=0; i<tagIds.value.length; i++) {
         		String[] tagIdsForEachInfo = tagIds.value[i];
         		for(int j=0; j<tagIdsForEachInfo.length; j++) {
         			contentnum++;
         		}
         	}
          	tagIDs.value = new String[contentnum];
          	int k = 0;
        	 for(int i=0; i<tagIds.value.length; i++) {
        		 String[] tagIdsForEachInfo = tagIds.value[i];
        		 for(int j=0; j<tagIdsForEachInfo.length; j++) {
        			 tagIDs.value[k] = new String();
        			 tagIDs.value[k] = tagIdsForEachInfo[j];
        			 k++;
        			 }
        		 }
        	 System.out.println("ok");
         }
         return ret;

    }

    public int getTagByComment(String comment, diStringListHolder tagIDs) {
        // Please insert your code here and remove the following warning pragma
        // TODO "Code missing in function <int getTagByComment(String comment, diData::diStringList tagIDs)>"
        System.out.println("Get Tag By Comment was called.");
        
        m_tag = m_tagBase._ptr();
        
        if(m_localtoken == null) {
        	System.out.println("no login");
        	return -1;
        }
        
        int ret = 0;
        
        Tag tag = m_tag.getInstance(m_localtoken);
        
        if(tag == null) {
        	System.out.println("failed");
        	return -1;
        }
        
        ContentObjectInfo _objInfo = new ContentObjectInfo();
        
        String[] keys = new String[]{"COMMENT"};
        _objInfo.comment = comment;
        _objInfo.name = "name";
        _objInfo.color = 0;
        _objInfo.size = "size";
        _objInfo.type = 0;
        _objInfo.manufacturer = "manufacturer";
        TimeVal date = new TimeVal();
        date.msec = 0;
        _objInfo.registration = date;
        _objInfo.width = 0;
        _objInfo.depth = 0;
        _objInfo.height = 0;
        _objInfo.history = date;
        _objInfo.status = 0;
        _objInfo.schedule = "schedule";
        _objInfo.cabinettype = 0;
        _objInfo.cabinetid = "cabinetid";
        
        TagObjectInfo objInfo = new TagObjectInfo();
        objInfo.m_contentObjectInfo(_objInfo);
        
        TagObjectInfo_Key objInfo_key = new TagObjectInfo_Key(objInfo, keys);
        TagObjectInfo_Key[] objInfo_keys = new TagObjectInfo_Key[]{objInfo_key};
        
        StringListListHolder tagIds = new StringListListHolder();
        
        System.out.println("CALL getTagIDByObjectInfo()");
        ret = m_tag.getTagIDByObjectInfo(objInfo_keys, tagIds);
        
        System.out.println("return code: "+ret);
        
        if(ret < 0) {
         	System.out.println("error");
         	tagIDs.value = new String[1];
         	tagIDs.value[0] = "";
         } else {
        	 int contentnum = 0;
          	for(int i=0; i<tagIds.value.length; i++) {
         		String[] tagIdsForEachInfo = tagIds.value[i];
         		for(int j=0; j<tagIdsForEachInfo.length; j++) {
         			contentnum++;
         		}
         	}
          	tagIDs.value = new String[contentnum];
          	int k = 0;
        	 for(int i=0; i<tagIds.value.length; i++) {
        		 String[] tagIdsForEachInfo = tagIds.value[i];
        		 for(int j=0; j<tagIdsForEachInfo.length; j++) {
        			 tagIDs.value[k] = new String();
        			 tagIDs.value[k] = tagIdsForEachInfo[j];
        			 k++;
        			 }
        		 }
        	 System.out.println("ok");
         }
        
        return ret;

    }

    public int getTagByCabinetID(String cabinetid, diStringListHolder tagIDs) {
        // Please insert your code here and remove the following warning pragma
        // TODO "Code missing in function <int getTagByCabinetID(String cabinetid, diData::diStringList tagIDs)>"
        System.out.println("Get Tag By CabinetID was called.");
        
        m_tag = m_tagBase._ptr();
         
         if(m_localtoken == null) {
         	System.out.println("no login");
         	return -1;
         }
         
         int ret = 0;
         
         Tag tag = m_tag.getInstance(m_localtoken);
         
         if(tag == null) {
         	System.out.println("failed");
         	return -1;
         }
         
         ContentObjectInfo _objInfo = new ContentObjectInfo();
         
         String[] keys = new String[]{"CABINET_ID"};
         _objInfo.cabinetid = cabinetid;
         _objInfo.name = "name";
         _objInfo.color = 0;
         _objInfo.size = "size";
         _objInfo.type = 0;
         _objInfo.manufacturer = "manufacturer";
         TimeVal date = new TimeVal();
         date.msec = 0;
         _objInfo.registration = date;
         _objInfo.comment = "comment";
         _objInfo.width = 0;
         _objInfo.depth = 0;
         _objInfo.height = 0;
         _objInfo.history = date;
         _objInfo.status = 0;
         _objInfo.schedule = "schedule";
         _objInfo.cabinettype = 0;
         
         
         TagObjectInfo objInfo = new TagObjectInfo();
         objInfo.m_contentObjectInfo(_objInfo);
         
         TagObjectInfo_Key objInfo_key = new TagObjectInfo_Key(objInfo, keys);
         TagObjectInfo_Key[] objInfo_keys = new TagObjectInfo_Key[]{objInfo_key};
         
         StringListListHolder tagIds = new StringListListHolder();

         System.out.println("CALL getTagIDByObjectInfo()");
         ret = m_tag.getTagIDByObjectInfo(objInfo_keys, tagIds);
         
         System.out.println("return code: " + ret);
                  
         if(ret < 0) {
         	System.out.println("error");
         	tagIDs.value = new String[1];
         	tagIDs.value[0] = "";
         } else {
        	 int contentnum = 0;
          	for(int i=0; i<tagIds.value.length; i++) {
         		String[] tagIdsForEachInfo = tagIds.value[i];
         		for(int j=0; j<tagIdsForEachInfo.length; j++) {
         			contentnum++;
         		}
         	}
          	tagIDs.value = new String[contentnum];
          	int k = 0;
        	 for(int i=0; i<tagIds.value.length; i++) {
        		 String[] tagIdsForEachInfo = tagIds.value[i];
        		 for(int j=0; j<tagIdsForEachInfo.length; j++) {
        			 tagIDs.value[k] = new String();
        			 tagIDs.value[k] = tagIdsForEachInfo[j];
        			 k++;
        			 }
        		 }
        	 System.out.println("ok");
         }
         return ret;
    }

//  End of example implementational code
}
